package se.softstuff.nb.nb.translate.ide;

import java.io.File;
import javax.swing.JFileChooser;
import javax.swing.JPanel;
import javax.swing.filechooser.FileFilter;
import org.openide.DialogDisplayer;
import org.openide.NotifyDescriptor;
import org.openide.util.NbBundle;
import org.openide.util.NbPreferences;

public final class CreateProjectVisualPanel3 extends JPanel {
    public static final String LAST_LOCATION = "lastLocation";


    /**
     * Creates new form CreateProjectVisualPanel3
     */
    public CreateProjectVisualPanel3() {
        initComponents();
        locationTextField.setText(NbPreferences.forModule(CreateProjectVisualPanel3.class).get(LAST_LOCATION, ""));
    }

    @Override
    public String getName() {
        return NbBundle.getMessage(getClass(), "CreateProjectVisualPanel3.bulletin");
    }

    public String getDestination() {
        return locationTextField.getText();
    }
    
    

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        locationLabel = new javax.swing.JLabel();
        locationTextField = new javax.swing.JTextField();
        browseButton = new javax.swing.JButton();

        setName("Form"); // NOI18N

        org.openide.awt.Mnemonics.setLocalizedText(locationLabel, NbBundle.getMessage(CreateProjectVisualPanel3.class, "CreateProjectVisualPanel3.locationLabel.text")); // NOI18N
        locationLabel.setName("locationLabel"); // NOI18N

        locationTextField.setName("locationTextField"); // NOI18N

        org.openide.awt.Mnemonics.setLocalizedText(browseButton, NbBundle.getMessage(CreateProjectVisualPanel3.class, "CreateProjectVisualPanel3.browseButton.text")); // NOI18N
        browseButton.setName("browseButton"); // NOI18N
        browseButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                browseButtonActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(locationTextField)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(browseButton, javax.swing.GroupLayout.PREFERRED_SIZE, 84, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(locationLabel, javax.swing.GroupLayout.PREFERRED_SIZE, 128, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(0, 322, Short.MAX_VALUE)))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGap(6, 6, 6)
                .addComponent(locationLabel)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(locationTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(browseButton))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
    }// </editor-fold>//GEN-END:initComponents

    private void browseButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_browseButtonActionPerformed
        String location = locationTextField.getText();
        JFileChooser destinationChooser = new JFileChooser(location);
        destinationChooser.setFileFilter(new CreateProjectVisualPanel3.TranslateFileFilter());
        destinationChooser.setFileSelectionMode(JFileChooser.FILES_ONLY);
        destinationChooser.setMultiSelectionEnabled(false);
        destinationChooser.setDialogTitle(NbBundle.getMessage(getClass(), "CreateProjectVisualPanel3.selectExportToDialog.title"));
        int answer = destinationChooser.showOpenDialog(this);
        if( answer != JFileChooser.APPROVE_OPTION ) {
            return;
        }
        
        File destination = destinationChooser.getSelectedFile();
        if(destination.exists()){
            NotifyDescriptor nd = new NotifyDescriptor(
                NbBundle.getMessage(getClass(), "CreateProjectVisualPanel3.overrideDialog.message", destination.getName()), // instance of your panel
                NbBundle.getMessage(getClass(), "CreateProjectVisualPanel3.overrideDialog.title"), // title of the dialog
                NotifyDescriptor.YES_NO_OPTION,
                NotifyDescriptor.QUESTION_MESSAGE,
                null, 
                NotifyDescriptor.YES_OPTION // default option is "Yes"
            );
            if (DialogDisplayer.getDefault().notify(nd) != NotifyDescriptor.YES_OPTION) {
                return;
            }
            destination.delete();            
        }
        locationTextField.setText( destination.getAbsolutePath() );
        NbPreferences.forModule(CreateProjectVisualPanel3.class).put(LAST_LOCATION, destination.getAbsolutePath());
        
    }//GEN-LAST:event_browseButtonActionPerformed

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton browseButton;
    private javax.swing.JLabel locationLabel;
    private javax.swing.JTextField locationTextField;
    // End of variables declaration//GEN-END:variables

    private static class TranslateFileFilter extends FileFilter {

        public TranslateFileFilter() {
        }

        @Override
        public boolean accept(File f) {
            return true;
        }

        @Override
        public String getDescription() {
            return NbBundle.getMessage(CreateProjectVisualPanel3.class, "CreateProjectVisualPanel3.fileFilter.description");
        }
    }
}
